import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import java.util.*;

/**
   A panel that shows a scene composed of items.
*/
public class CarPanel extends JPanel
{
   public CarPanel()
   {
      car = new CarShape(20, 20, 50);
      addMouseListener(new
         MouseAdapter()
         {
            public void mousePressed(MouseEvent event)
            {
               mousePoint = event.getPoint();
               if (!car.contains(mousePoint))
                  mousePoint = null;
            }
         });

      addMouseMotionListener(new
         MouseMotionAdapter()
         {
            public void mouseDragged(MouseEvent event)
            {
               if (mousePoint == null) return;
               Point lastMousePoint = mousePoint;
               mousePoint = event.getPoint();

               car.translate(
                  mousePoint.getX() - lastMousePoint.getX(),
                  mousePoint.getY() - lastMousePoint.getY());
               repaint();
            }
         });
   }

   public void paintComponent(Graphics g)
   {
      super.paintComponent(g);
      Graphics2D g2 = (Graphics2D) g;
      car.draw(g2);
   }

   private CarShape car;
   private Point mousePoint;
}                               
